import java.awt.Dialog;
import java.awt.Frame;
import java.awt.GraphicsConfiguration;
import java.awt.HeadlessException;
import java.awt.GridBagLayout;
import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;
import java.awt.TextArea;
import java.awt.GridBagConstraints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Color;
import java.awt.Button;
import java.awt.TextField;
import java.awt.Scrollbar;
import java.awt.Label;
import java.io.File;
import java.awt.Font;
import java.io.FileWriter;
import java.io.FileReader;
import java.io.BufferedReader;
import java.awt.Insets;

import javax.swing.Box;
import javax.swing.BoxLayout;

public class EditFrame extends Frame implements ActionListener{
	
	String fileName;

	private static final long serialVersionUID = 1L;
	private TextArea textArea = null;
	private Button button1 = null;
	private TextField textField1 = null;
	private Scrollbar scrollbar1 = null;
	private Label label1 = null;
	public EditFrame() throws HeadlessException {
		// TODO ꂽRXgN^[EX^u
		super();
//		fileName = "test";
		initialize();
	}

	public EditFrame(GraphicsConfiguration arg0) {
		super(arg0);
		// TODO ꂽRXgN^[EX^u
		initialize();
	}

	public EditFrame(String fname, String status) throws HeadlessException {
		super(fname);
		// TODO ꂽRXgN^[EX^u
		fileName = fname;
		
		if (status.equals("new")) {
			initialize();
		} else {
			File openFile = new File("work" + File.separator + fileName);
			initialize();
			try {
				FileReader rf = new FileReader(openFile);
				/*
				 * int c; while ((c = rf.read()) != -1){
				 * textArea.append(Integer.toString(c)); }
				 */
				BufferedReader br = new BufferedReader(rf);
				String line;
				while ((line = br.readLine()) != null) {
					textArea.append(line + "\r\n");
				}

				rf.close();
				br.close();
			} catch (Exception error) {
				System.out.println("t@CJ܂łB");
				System.out.println("QF" + error);
			}
		}
	}

	public EditFrame(String arg0, GraphicsConfiguration arg1) {
		super(arg0, arg1);
		// TODO ꂽRXgN^[EX^u
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
		gridBagConstraints4.gridx = 0;
		gridBagConstraints4.gridy = 2;
		label1 = new Label();
		label1.setText("̑傫");
		GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
		gridBagConstraints3.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints3.gridx = 1;
		gridBagConstraints3.gridy = 2;
		gridBagConstraints3.weightx = 1.0;
		gridBagConstraints3.weighty = 1.0;
		gridBagConstraints3.gridheight = 1;
		gridBagConstraints3.insets = new Insets(0,0,0,0);
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.fill = GridBagConstraints.BOTH;
		gridBagConstraints2.gridx = 1;
		gridBagConstraints2.gridy = 0;
		gridBagConstraints2.weightx = 1.0;
		gridBagConstraints2.anchor = GridBagConstraints.WEST;
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 0;
		gridBagConstraints1.fill = GridBagConstraints.BOTH;
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.weighty = 1.0;
		gridBagConstraints.gridwidth = 2;
		gridBagConstraints.gridheight = 1;
		gridBagConstraints3.insets = new Insets(0,0,0,0);
		this.setLayout(new GridBagLayout());
		this.setSize(300, 200);
		this.setTitle(fileName);
		
//		createMenu();

		this.setVisible(true);
		this.add(getTextArea(), gridBagConstraints);
		this.add(getButton1(), gridBagConstraints1);
		this.add(getTextField1(), gridBagConstraints2);
		this.add(getScrollbar1(), gridBagConstraints3);
		this.add(label1, gridBagConstraints4);
		this.pack();
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				System.out.println("windowClosing()"); // TODO Auto-generated Event stub windowClosing()
				fileClose();
			}
		});
	}

	/**
	 * This method initializes textArea	
	 * 	
	 * @return java.awt.TextArea	
	 */
	private TextArea getTextArea() {
		if (textArea == null) {
			textArea = new TextArea("",0,0,TextArea.SCROLLBARS_VERTICAL_ONLY);
			textArea.setForeground(Color.white);
			textArea.setBackground(new Color(0,0,150));
		}
		return textArea;
	}
	private void createMenu(){
		MenuBar menuBar = new MenuBar();
		
		Menu menu1 = new Menu();
		menu1.setLabel("menu1");
		menu1.addActionListener(this);
			MenuItem menu1a = new MenuItem();
			menu1a.setLabel("menu1-1");
			menu1.add(menu1a);
			MenuItem menu1b = new MenuItem();
			menu1b.setLabel("menu1-2");
			menu1.add(menu1b);
			MenuItem menu1c = new MenuItem();
			menu1c.setLabel("menu1-3");
			menu1.add(menu1c);
			menuBar.add(menu1);
		Menu menu2 = new Menu();
		menu2.setLabel("menu2");
			MenuItem menu2a = new MenuItem();
			menu2a.setLabel("menu2-1");
			menu2.add(menu2a);
			menu2a.addActionListener(this);
			MenuItem menu2b = new MenuItem();
			menu2b.setLabel("menu2-2");
			menu2.add(menu2b);
			menu2b.addActionListener(this);
			menuBar.add(menu2);

			this.setMenuBar(menuBar);
			
	}

	public void actionPerformed(ActionEvent action){
		if (action.getActionCommand().equals("shutdown")){
			StartFrame frame = new StartFrame();
			frame.setVisible(true);
			dispose();
		} else if (action.getActionCommand().equals("dialog")){
			if (tf.getText().equals("")){
				
			} else {
				textField1.setText(tf.getText());
				this.fileClose();
			}
		}
	}

	/**
	 * This method initializes button1	
	 * 	
	 * @return java.awt.Button	
	 */
	private Button getButton1() {
		if (button1 == null) {
			button1 = new Button();
			button1.setLabel("{^");
/*			button1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
					textField1.setText(textField1.getAccessibleContext().getAccessibleStateSet().toString());
					String a = textField1.getAccessibleContext().getAccessibleStateSet().toString();
					if (a.indexOf("ҏW\") != -1){
						if (textField1.getText().equals("")){
							textField1.setText("薼");
						} else {
						textField1.setText("ҏWs");
						textField1.setEditable(false);
						button1.setLabel("薼C");
						}
					} else {
						textField1.setText("ҏW\");
						textField1.setEditable(true);
						button1.setLabel("ҏW\");
					}
				}
			});
*/		}
		return button1;
	}

	/**
	 * This method initializes textField1	
	 * 	
	 * @return java.awt.TextField	
	 */
	private TextField getTextField1() {
		if (textField1 == null) {
			textField1 = new TextField();
			textField1.setBackground(new Color(0,200,200));
			textField1.setText(fileName);
		}
		return textField1;
	}

	/**
	 * This method initializes scrollbar1	
	 * 	
	 * @return java.awt.Scrollbar	
	 */
	private Scrollbar getScrollbar1() {
		if (scrollbar1 == null) {
			scrollbar1 = new Scrollbar();
			scrollbar1.setOrientation(Scrollbar.HORIZONTAL);
			scrollbar1.setMinimum(10);
			scrollbar1.setMaximum(72);
			scrollbar1.setValue(12);
			scrollbar1.setUnitIncrement(1);
			scrollbar1.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
				public void adjustmentValueChanged(java.awt.event.AdjustmentEvent e) {
					System.out.println("adjustmentValueChanged()"); // TODO Auto-generated Event stub adjustmentValueChanged()
					System.out.println(scrollbar1.getValue());
					System.out.println(textArea.getFont());
					int size = scrollbar1.getValue();
					textArea.setFont(new Font("Dialog",Font.PLAIN,size));
				}
			});
		}
		return scrollbar1;
	}
	
	private void fileClose(){
		if (textField1.getText().equals("")){
			this.closeDialog();
		} else {		
			try {
				File path = new File("work");
				fileName = textField1.getText();
//				FileWriter writeFile = new FileWriter(path + File.separator + fileName + ".txt");
				FileWriter writeFile = new FileWriter(path + File.separator + fileName);
				writeFile.write(textArea.getText());
				writeFile.close();

				StartFrame frame = new StartFrame();
				frame.setVisible(true);
				dispose();
				
			} catch (Exception error) {
				System.out.println("t@Cۑł܂łB");
				System.out.println("QF" + error);
			}
		}

	}
	
	TextField tf;
	
	private void closeDialog(){
		Dialog dialog = new Dialog(this);
		dialog.setModal(true);
		dialog.setResizable(false);
		
		Box box = new Box(BoxLayout.Y_AXIS);
			box.setSize(300, 0);
		box.add(Box.createVerticalStrut(5));
		Label label = new Label();
			label.setAlignment(Label.CENTER);
			label.setFont(new Font("Dialog", Font.PLAIN, 18));
			label.setText("薼͂̏ꍇA͔j܂B");
		box.add(label);
		Button shutDown = new Button();
			shutDown.setFont(new Font("Dialog", Font.PLAIN, 20));
			shutDown.setLabel("jďI");
			shutDown.setActionCommand("shutdown");
			shutDown.addActionListener(this);
		box.add(shutDown);
		box.add(Box.createVerticalStrut(20));
		tf = new TextField();
			tf.setBackground(new Color(0,200,200));
			tf.setFont(new Font("Dialog", Font.PLAIN, 20));
		box.add(tf);
		box.add(Box.createVerticalStrut(5));
		Button dbtn = new Button();
			dbtn.setFont(new Font("Dialog", Font.PLAIN, 20));
			dbtn.setLabel("薼");
			dbtn.setActionCommand("dialog");
			dbtn.addActionListener(this);
		box.add(dbtn);
		box.add(Box.createVerticalStrut(5));
		
		dialog.add(box);
		dialog.pack();
		dialog.setVisible(true);
	}

}
